#ifndef VUMeterNode_H
#define VUMeterNode_H

#include <BufferConsumer.h>
#include <MediaEventLooper.h>
#include <Window.h>
#include <View.h>

class VUMeterNode : public BBufferConsumer, public BMediaEventLooper
{
public:
	VUMeterNode();
	virtual ~VUMeterNode();

// pure virtual from BMediaNode
public:
	virtual BMediaAddOn* AddOn( int32 *internal_id ) const;

// pure virtual from BBufferConsumer
protected:

	virtual	status_t GetNextInput(
				int32 *cookie,
				media_input *out_input );

	virtual	void DisposeInputCookie(
				int32 cookie );

	virtual	status_t AcceptFormat(
				const media_destination &destination,
				media_format * format );

	virtual	status_t Connected(
				const media_source &source,
				const media_destination &destination,
				const media_format &format,
				media_input *out_input );

	virtual	void Disconnected(
				const media_source &source,
				const media_destination &destination );

	virtual	status_t GetLatencyFor(
				const media_destination &destination,
				bigtime_t *out_latency,
				media_node_id *out_timesource );

	virtual	void BufferReceived(
				BBuffer *buffer );

	virtual	void ProducerDataStatus(
				const media_destination &destination,
				int32 status,
				bigtime_t at_performance_time );

	virtual	status_t FormatChanged(
				const media_source &source,
				const media_destination &destination, 
				int32 change_tag,
				const media_format &format );

// pure virtual from BMediaEventLooper class
protected:
	virtual void HandleEvent(
				const media_timed_event *event,
				bigtime_t lateness,
				bool realTimeEvent = false );

// private data members specific for VUMeterNode class
private:

	void Measure( BBuffer* buffer );

	media_input mInput;

	BWindow* pWindow;
	BView* pLeftView;
	BView* pRightView;
};

#endif
